<?php

namespace app\controllers;
use app\app;
class lnurlp
{
    public static function index()
    {
        header(header: 'Content-Type: application/json');
        $host = $_SERVER['HTTP_HOST'];
        $user = $_GET["username"] ?? false;
        $paymentRequest = $_GET["pay"] ?? false;
        $verify = $_GET["verify"] ?? false;

        function returnJson($arr): never
        {
            echo json_encode(value: $arr);
            exit();
        }

        // for when the callback is used incorrectly
        if ($paymentRequest != 1 && $paymentRequest != false) {
            returnJson([
                'status' => 'ERROR',
                'reason' => 'invalid value for `pay` param (set `pay=1` or exclude `pay` from the url)',
            ]);
        }
        // for when the user is missing
        if ($user == false && $verify == false) {
            returnJson([
                'status' => 'ERROR',
                'reason' => 'no user specified (set `username=<name>` in the url)',
            ]);
        }

 
        list($proxy_user, $proxy_host) = explode("@", $_ENV['LN_ADDRESS']);
        

        // for when the client makes it's first call (querying the lightning address)
        $metadata = "[[\"text/plain\",\"Funding @$user on $host\"],[\"text/identifier\",\"$user@$host\"]]";
        if ($paymentRequest == false && $verify == false) {
            $res = json_decode(file_get_contents("https://$proxy_host/.well-known/lnurlp/$proxy_user"), true);
            returnJson(
                [
                    'callback' => "https://$host/lnurlp?pay=1&username=$user",
                    'maxSendable' => $res['maxSendable'],
                    'minSendable' => $res['minSendable'],
                    'metadata' => $metadata,
                    'commentAllowed' => $res['commentAllowed'],
                    'payerData' => $res['payerData'],
                    'tag' => "payRequest",
                ]
            );
        }

        // for when the client makes it's second call (callback)
        if ($paymentRequest == "1") {
            $proxy_url = "https://$proxy_host/lnurlp?pay=1&username=$proxy_user";
            if (isset($_GET["amount"])) {
                $proxy_url .= "&amount=" . urlencode($_GET["amount"]);
            }
            $res = json_decode(file_get_contents($proxy_url), true);
            if ($res['status'] === 'OK'){
                $boom = explode("=", $res['verify']);
                $proxy_verify = end($boom);
                returnJson([
                    'status' => 'OK',
                    'pr' => $res['pr'],
                    'routes' => $res['routes'],
                    'verify' => "https://$host/lnurlp?verify=$proxy_verify"
                ]);
            } else {
                returnJson($res);
            }
        }

        // for when they want to verify the payment succeeded
        if ($verify) {
            $res = json_decode(file_get_contents("https://$proxy_host/lnurlp?verify=$verify"), true);
            returnJson($res);
        }

        // for when none of the above conditions are met
        returnJson([
            'status' => 'ERROR',
            'reason' => 'unhandled error (how did you get here?)',
        ]);
    }
}